#include <iostream>
#include <chrono>

auto start = std::chrono::high_resolution_clock::now();
auto end = std::chrono::high_resolution_clock::now();

unsigned long long n = 1;

unsigned long long fib(unsigned long long n) {
    if(n == 1)
        return 1;

    if(n == 2)
        return 1;
    else if(n > 2) {
        unsigned long long prevFib = 1;
        unsigned long long currFib = 1;

        for(unsigned long long i = 3; i <= n; ++i) {
            unsigned long long temp = currFib;
            currFib = prevFib + currFib;
            prevFib = temp;
        }

        return currFib;
    }
    else
        return 0;
}

int main(int argc, char const* argv[]) {
    if(argc > 1)
        n = std::stoi(std::string(argv[1]));
    else
        return 1;

    start = std::chrono::high_resolution_clock::now();

    unsigned long long res = fib(n);

    end = std::chrono::high_resolution_clock::now();
    std::cout << std::chrono::duration_cast<std::chrono::nanoseconds>(end - start).count() << std::endl;

    std::cout << res;

    return 0;
}
